(defun k_satz->entlist (satz)
  (if (= (type satz) 'PICKSET)
    (vl-remove-if-not
      '(lambda (dummy) (= (type dummy) 'ENAME))
      (mapcar 'cadr (ssnamex satz))
    )
  )
)

(defun k_satz->objlist (satz)
  (mapcar 'vlax-ename->vla-object (k_satz->entlist satz))
)

(defun k_ac-doc	()
  (vla-get-activedocument (vlax-get-acad-object))
)

(defun k_ofang (modus)
;;; Objektfangeinstellungen aus/Einschalten, speichern, wieder herstellen

;;; (k_ofang "ein")
;;; (k_ofang "aus")
;;; (k_ofang "mem")
;;; (k_ofang "restore")
;;; (k_ofang 1)     unter dieser Nummer speichern
;;; (k_ofang -1)    unter dieser Nummer gespeicherte wiederherstellen

  (cond
    ((and (= modus "aus") (= (logand (getvar "osmode") 16384) 0))
     (setvar "osmode" (+ (getvar "osmode") 16384))
    )
    ((and (= modus "ein")
	  (= (logand (getvar "osmode") 16384) 16384)
     )
     (setvar "osmode" (- (getvar "osmode") 16384))
    )

    ((= (type modus) 'INT)
     (if (minusp modus)
       (setvar "osmode"
	       (k_get_hauptliste (strcat "osmode" (itoa (abs modus))))
       )
       (k_put_hauptliste
	 (strcat "osmode" (itoa modus))
	 (getvar "osmode")
       )
     )
    )

    ((= modus "mem")
     (k_put_hauptliste "osmode" (getvar "osmode"))
    )
    ((and (= modus "restore") (k_get_hauptliste "osmode"))
     (setvar "osmode" (k_get_hauptliste "osmode"))
    )
  )
)

(defun k_variant->list (dummy)
  (vlax-safearray->list
    (vlax-variant-value
      dummy
    )
  )
)

(defun k_liste->variant	(liste typ)
;;;  erstellt aus einer Koordinatenliste einen Variant
  (vlax-make-variant
    (vlax-safearray-fill
      (vlax-make-safearray
	5
	(cons 0 (1- (length liste)))
      )
      liste
    )
    typ
  )
)

(defun ml_segmentumrisse
       (ent_name / ent_data FERTIG_LIST P_LIST ml_liste_trennen)
;;;  gibt fr jedes Multiliniensegment eine Liste der Umgrenzungspunkte zurck

  (defun ml_liste_trennen
	 (liste trenner / dummy_list fertig_list data ok)
    (setq fertig_list (list))
    (setq ok nil)
    (foreach data liste
      (if (= (car data) trenner)
	(progn
	  (setq ok t)
	  (if dummy_list
	    (setq fertig_list (cons (reverse dummy_list) fertig_list))
	  )
	  (setq dummy_list (list))
	)
      )
      (if ok
	(setq dummy_list (cons data dummy_list))
      )
    )
    (reverse (cons (reverse dummy_list) fertig_list))
  )

  (cond
    ((= (type ent_name) 'ENAME)
     (setq ent_data (entget ent_name))
    )
    ((= (type ent_name) 'VLA-OBJECT)
     (setq ent_data (entget (vlax-vla-object->ename ent_name)))
    )
    (t nil)
  )

  (setq ent_data (entget ent_name))
  (setq p_list (list))
  (setq dummy_list (list))
  (setq ausricht (cdr (assoc 70 ent_data)))
  (setq offen (cdr (assoc 71 ent_data)))
  (setq punkte (cdr (assoc 72 ent_data)))
  (setq elemente (cdr (assoc 73 ent_data)))
  (setq punkte_list (ml_liste_trennen ent_data 11))
  (setq nummer 1)
  (setq p1_list (list))
  (setq p2_list (list))
  (foreach punkt punkte_list
    (setq p_x (cdr (assoc 11 punkt)))
    (setq richt_p (cdr (assoc 12 punkt)))
    (setq gehr_p (cdr (assoc 13 punkt)))
    (setq richt_w (angle (list 0.0 0.0 0.0) richt_p))
    (setq gehr_w (angle (list 0.0 0.0 0.0) gehr_p))
    (setq linien_list (ml_liste_trennen punkt 74))
    (if	(> (length linien_list) 2)
      (setq linien_list
	     (list (nth 0 linien_list) (last linien_list))
      )
    )
    (if	(< nummer (length punkte_list))
      (progn
	(setq ende_list (list))
	(setq linie (nth 0 linien_list))
	(while (/= (car (nth 0 linie)) 41)
	  (setq linie (cdr linie))
	)
	(setq abstand (cdr (nth 0 linie)))
	(setq anfang (cdr (nth 1 linie)))
	(setq p (polar p_x gehr_w abstand))
	(if (= nummer 1)
	  (setq p (polar p richt_w anfang))
	)
	(setq p1_list (cons p p1_list))
	(if (nth 3 linie)
	  (progn
	    (setq p (polar p_x gehr_w abstand))
	    (foreach dat_41 linie
	      (if (= (car dat_41) 41)
		(setq anfang (cdr dat_41))
	      )
	    )
	    (setq ende_list
		   (cons (polar p richt_w anfang) ende_list)
	    )
	  )
	  (setq ende_list (cons nil ende_list))
	)
	(setq linie (nth 1 linien_list))
	(while (/= (car (nth 0 linie)) 41)
	  (setq linie (cdr linie))
	)
	(setq abstand (cdr (nth 0 linie)))
	(setq anfang (cdr (nth 1 linie)))
	(setq p (polar p_x gehr_w abstand))
	(if (= nummer 1)
	  (setq p (polar p richt_w anfang))
	)
	(setq p2_list (cons p p2_list))
	(if (nth 3 linie)
	  (progn
	    (setq p (polar p_x gehr_w abstand))
	    (foreach dat_41 linie
	      (if (= (car dat_41) 41)
		(setq anfang (cdr dat_41))
	      )
	    )
	    (setq ende_list
		   (cons (polar p richt_w anfang) ende_list)
	    )
	  )
	  (setq ende_list (cons nil ende_list))
	)
      )
      (progn
	(setq ende_list (reverse ende_list))
	(setq linie (nth 0 linien_list))
	(while (/= (car (nth 0 linie)) 41)
	  (setq linie (cdr linie))
	)
	(setq abstand (cdr (nth 0 linie)))
	(setq anfang (cdr (nth 1 linie)))
	(if (<= (length linie) 2)
	  (if (nth 0 ende_list)
	    (setq p (nth 0 ende_list))
	    (progn
	      (setq p (polar p_x gehr_w abstand))
	      (setq p (polar p richt_w anfang))
	    )
	  )
	  (progn
	    (foreach dat_41 linie
	      (if (= (car dat_41) 41)
		(setq anfang (cdr dat_41))
	      )
	    )
	    (setq p (polar p_x gehr_w abstand))
	    (setq p (polar p richt_w anfang))
	  )
	)
	(setq p1_list (cons p p1_list))
	(setq ende_list (cdr ende_list))
	(setq linie (nth 1 linien_list))
	(while (/= (car (nth 0 linie)) 41)
	  (setq linie (cdr linie))
	)
	(setq abstand (cdr (nth 0 linie)))
	(setq anfang (cdr (nth 1 linie)))
	(if (<= (length linie) 2)
	  (if (nth 0 ende_list)
	    (setq p (nth 0 ende_list))
	    (progn
	      (setq p (polar p_x gehr_w abstand))
	      (setq p (polar p richt_w anfang))
	    )
	  )
	  (progn
	    (foreach dat_41 linie
	      (if (= (car dat_41) 41)
		(setq anfang (cdr dat_41))
	      )
	    )
	    (setq p (polar p_x gehr_w abstand))
	    (setq p (polar p richt_w anfang))
	  )
	)
	(setq p2_list (cons p p2_list))
	(setq ende_list (cdr ende_list))
      )
    )
    (setq nummer (1+ nummer))
  )

  (setq segment_list (list))
  (setq n 0)
  (repeat (1- (length p1_list))
    (setq segment_list
	   (cons (list (nth n p1_list)
		       (nth (1+ n) p1_list)
		       (nth (1+ n) p2_list)
		       (nth n p2_list)
		 )
		 segment_list
	   )
    )
    (setq n (1+ n))
  )

  (foreach p_list segment_list
    (setq dummy_list nil)
    (foreach p p_list
      (setq dummy_list (append dummy_list (list p)))
    )
    (setq fertig_list (append fertig_list (list dummy_list)))
  )
  fertig_list
)

(defun k_put_hauptliste	(name wert)
  (if (assoc name k_hauptliste)
    (setq k_hauptliste
	   (subst (list name wert)
		  (assoc name k_hauptliste)
		  k_hauptliste
	   )
    )
    (setq k_hauptliste (cons (list name wert) k_hauptliste))
  )
  (princ)
)

(defun k_get_hauptliste	(name / wert)
  (if (assoc name k_hauptliste)
    (setq wert (nth 1 (assoc name k_hauptliste)))
  )
  wert
)

(defun k_ac-layout (file)
  (if file
    (vla-get-activelayout file)
    (vla-get-activelayout
      (k_ac-doc)
    )
  )
)

(defun gather (lst len)
;;;  bndelt die angebende Anzahl an Listen-Elementen zu Unterlisten besagter Lnge
  (cond
    ((null lst) nil)
    ((> (length lst) len)
     (cons (n-car len lst) (gather (n-cdr len lst) len))
    )
    ('sonst (list lst))
  )
)

(defun n-car (n lst / res)
;;;  liefert die n Elemente vom Anfang einer Liste wieder als Liste zurck
  (repeat (min n (length lst))
    (setq res (cons (car lst) res)
	  lst (cdr lst)
    )
  )
  (reverse res)
)

(defun n-cdr (n lst)
;;;  liefert den Rest einer Liste nach den ersten n Elementen wieder als Liste zurck
  (repeat n
    (setq lst (cdr lst))
  )
)

(defun k_plist->hatch (p_list / HT-NAME PL-NAME)
;;;  Schraffieren ohne command
  (setq p_list (mapcar 'k_3d->2d p_list))
  (setq p_list (apply 'append p_list))

  (setq	pl-name	(vla-AddLightWeightPolyline
		  (vla-get-modelspace
		    (vla-get-activedocument (vlax-get-acad-object))
		  )
		  (k_liste->variant p_list 8197)
		)
  )
  (vla-put-closed pl-name :vlax-true)

  (setq	ht-name	(vla-AddHatch
		  (vla-get-modelspace
		    (vla-get-activedocument (vlax-get-acad-object))
		  )
		  acHatchObject
		  (getvar "hpname")
		  :vlax-false
		)
  )

  (vla-AppendOuterLoop
    ht-name
    (list_to_variant (list pl-name) vlax-vbObject)
  )
  (vla-put-PatternScale ht-name (getvar "hpscale"))
  (vla-put-PatternAngle ht-name (getvar "hpang"))
  (vla-delete pl-name)
)

(defun mk_angle_korr (data_list_alt data_list_neu)
;;; Winkelkorrektur beim Strecken von Multilinien
  (defun mk_plist (ent_data / p_list)
    (setq p_list (list))
    (foreach dat ent_data
      (if (= (car dat) 11)
	(setq p1 (cdr dat))
      )
      (if (= (car dat) 12)
	(progn
	  (setq p2 (mapcar '+ p1 (cdr dat)))
	  (setq p_list (cons (list p1 p2) p_list))
	)
      )
    )
    (setq p_list (reverse p_list))
  )

  (vla-startundomark (k_ac-doc))
  (setvar "cmdecho" 0)
  (setq n 0)
  (foreach ent_data data_list_alt
    (setq ent_name (cdr (assoc -1 ent_data)))
    (setq p_alt_list (mk_plist ent_data))
    (setq m 0)
    (while
      (not
	(equal (cdr (assoc -1 ent_data))
	       (cdr (assoc -1 (setq edit_data (nth m data_list_neu))))
	)
      )
       (setq m (1+ m))
    )
    (setq p_neu_list (mk_plist edit_data))
    (setq p_v_list (list (nth 0 (nth 0 p_neu_list))))
    (setq p 0)
    (repeat (1- (length p_alt_list))
      (if (not (equal (nth p p_alt_list) (nth (1+ p) p_neu_list)))
	(setq p0 (inters (nth 0 (nth p p_alt_list))
			 (nth 1 (nth p p_alt_list))
			 (nth 0 (nth (1+ p) p_neu_list))
			 (nth 1 (nth (1+ p) p_neu_list))
			 nil
		 )
	)
	(setq p0 (nth 0 (nth p p_alt_list)))
      )
      (if p0
	(setq p_v_list (cons p0 p_v_list))
      )
      (setq p (1+ p))
    )
    (setq
      p_v_list (reverse	(cons (nth 0 (nth 0 (reverse p_neu_list)))
			      p_v_list
			)
	       )
    )
    (setq p_r_list (list (nth 0 (nth 0 p_neu_list))))
    (setq p 1)
    (repeat (1- (length p_alt_list))
      (if (not (equal (nth p p_alt_list) (nth (1- p) p_neu_list)))
	(setq p0 (inters (nth 0 (nth p p_alt_list))
			 (nth 1 (nth p p_alt_list))
			 (nth 0 (nth (1- p) p_neu_list))
			 (nth 1 (nth (1- p) p_neu_list))
			 nil
		 )
	)
	(setq p0 (nth 0 (nth p p_alt_list)))
      )
      (if p0
	(setq p_r_list (cons p0 p_r_list))
      )
      (setq p (1+ p))
    )
    (setq
      p_r_list (reverse	(cons (nth 0 (nth 0 (reverse p_neu_list)))
			      p_r_list
			)
	       )
    )
    (setq p 0)
    (setq dummy_list (list))
    (setq p 0)
    (setq next_list nil)
    (foreach data ent_data
      (if (/= (car data) 11)
	(setq dummy_list (cons data dummy_list))
	(progn
	  (if next_list
	    (progn
	      (setq dummy_list (cons next_list dummy_list))
	      (setq next_list nil)
	    )
	    (cond
	      ((equal (rtos (angle (nth 0 (nth p p_alt_list))
				   (nth 1 (nth p p_alt_list))
			    )
		      )
		      (rtos (angle (nth 0 (nth p p_neu_list))
				   (nth 1 (nth p p_neu_list))
			    )
		      )
	       )
	       (setq dummy_list
		      (cons
			(cons 11 (nth 0 (nth p p_neu_list)))
			dummy_list
		      )
	       )
	      )
	      ((and (equal (nth 0 (nth p p_alt_list))
			   (nth 0 (nth p p_neu_list))
		    )
		    (not (equal	(angle (nth 0 (nth p p_alt_list))
				       (nth 1 (nth p p_alt_list))
				)
				(angle (nth 0 (nth p p_neu_list))
				       (nth 1 (nth p p_neu_list))
				)
			 )
		    )
	       )
	       (setq dummy_list
		      (cons
			(cons 11 (nth 0 (nth p p_neu_list)))
			dummy_list
		      )
	       )
	       (setq next_list (cons 11 (nth (1+ p) p_v_list)))
	      )
	      (t
	       (setq dummy_list
		      (cons (cons 11 (nth p p_r_list))
			    dummy_list
		      )
	       )
	      )
	    )
	  )
	  (setq p (1+ p))
	)
      )
    )
    (entmod (reverse dummy_list))
    (setq n (1+ n))
  )
)

(defun pline->p_list (ent_data / bogen p_list dat)
;;; Kontrollpunkte einer LW-Polylinie als Liste zurckgeben und Bogensegmente "nachzeichnen"
  (setq p_list (list))
  (setq bogen f)
  (foreach dat ent_data
    (if	(= (car dat) 10)
      (progn
	(if bogen
	  (rechne_bogen (car p_list) (cdr dat))
	)
	(setq p_list (cons (cdr dat) p_list))
	(setq bogen f)
      )
    )
    (if	(= (car dat) 42)
      (progn
	(if (/= (cdr dat) 0)
	  (setq bogen (cdr dat))
	  (setq bogen f)
	)
      )
    )
  )
  (if (= (rem (cdr (assoc 70 ent_data)) 2) 1)
    (if	bogen
      (rechne_bogen (car p_list) (car (reverse p_list)))
    )
  )
  (setq p_list (reverse p_list))
  p_list
)

(defun rechne_bogen (p1 p2)
;;; Bogensegment von LW-Polylinie "nachzeichnen"
  (setq s (distance p1 p2))
  (setq w (angle p1 p2))
  (setq h (* bogen (/ s 2.0)))
  (setq	m (polar (mapcar '(lambda (x1 x2) (/ (+ x1 x2) 2.0)) p1 p2)
		 (- w (/ pi 2.0))
		 h
	  )
  )
  (setq r (+ (/ h 2.0) (/ (expt s 2.0) (* h 8.0))))
  (setq z (polar m (+ w (/ pi 2.0)) r))
  (setq w_x (abs (- (angle m p1) (angle m p2))))
  (if (> w_x w_max)
    (progn
      (setq teilung (/ w_x w_max))
      (setq w1 (angle z p1))
      (setq w2 (angle z p2))
      (if (equal w1 (* pi 2) 0.001)
	(setq w1 0.0)
      )
      (if (equal w2 (* pi 2) 0.001)
	(setq w2 0.0)
      )
      (cond
	((and (minusp bogen) (< w1 w2))
	 (setq w_t (- 0 (/ (- (* 2.0 pi) (- w1 w2)) teilung)))
	)
	((and (minusp bogen) (> w1 w2))
	 (setq w_t (- 0 (/ (- (* 2.0 pi) (- w2 w1)) teilung)))
	)
	((and (not (minusp bogen)) (> w1 w2))
	 (setq w_t (/ (- w1 w2) teilung))
	)
	((and (not (minusp bogen)) (< w1 w2))
	 (setq w_t (/ (- w2 w1) teilung))
	)
      )
      (if (> (abs bogen) 0.01)
	(progn
	  (while (< (abs bogen) (abs w_t))
	    (setq w_t (/ w_t 2.0))
	  )
	  (cond
	    ((and (minusp w_t) (< (abs w_t) (/ pi 16)))
	     (setq w_t (- 0 (/ pi 16)))
	    )
	    ((and (not (minusp w_t)) (< (abs w_t) (/ pi 16)))
	     (setq w_t (/ pi 16))
	    )
	    (t nil)
	  )
	  (setq w1 (angle z (polar z (+ w1 w_t) (abs r))))
	  (while
	    (and
	      (not (equal (angle z (polar z w1 (abs r))) w2 (/ w_t 2))
	      )
	      (not (equal (angle z (polar z (+ w1 pi) (abs r)))
			  (+ w2 pi)
			  (/ w_t 2)
		   )
	      )
	    )
	     (setq p_x (polar z w1 (abs r)))
	     (setq p_list (cons p_x p_list))
	     (setq w1 (angle z (polar z (+ w1 w_t) (abs r))))
	  )
	)
	(setq p_list (cons p2 p_list))
      )
    )
  )
)

(defun get_snapang_pickent (pic)
;;;  Berechnung fr Fangwinkel
  (setq ent_name (nth 0 pic))
  (setq ent_data (entget ent_name))
  (setq px (nth 1 pic))
  (setq p1 (osnap (nth 1 (nentselp px)) "_near"))
  (if (null (setq p0 (osnap px "_cen")))
    (setq p0 (osnap px "_endp"))
  )
  (setq w (angle p0 p1))

  (cond
    ((and (> w (* pi 0.25)) (<= w (* pi 0.5)))
     (setq w (+ w (* pi 1.5)))
    )
    ((and (> w (* pi 0.5)) (<= w (* pi 0.75)))
     (setq w (- w (* pi 0.5)))
    )
    ((and (> w (* pi 0.75)) (<= w (* pi 1)))
     (setq w (+ w (* pi 1)))
    )
    ((and (> w (* pi 1)) (<= w (* pi 1.25)))
     (setq w (- w (* pi 1)))
    )
    ((and (> w (* pi 1.25)) (<= w (* pi 1.5)))
     (setq w (+ w (* pi 0.5)))
    )
    ((and (> w (* pi 1.5)) (<= w (* pi 1.75)))
     (setq w (- w (* pi 1.5)))
    )
    (t nil)
  )
  (setvar "snapang" w)
)

(defun ml_ecken	(ent_name   nr	       /	  ent_data   punkte_list
		 dummy	    p	       p1	  p2	     p_list
		 dummy_list ausricht   offen	  punkte     elemente
		 nummer	    p_x	       richt_p	  gehr_p     richt_w
		 gehr_w	    linien_list		  ende_list  linie
		 dat_41
		)
  (defun liste_trennen
		       (liste trenner / dummy_list fertig_list data ok)
    (setq fertig_list (list))
    (setq ok nil)
    (foreach data liste
      (if (= (car data) trenner)
	(progn
	  (setq ok t)
	  (if dummy_list
	    (setq fertig_list (cons (reverse dummy_list) fertig_list))
	  )
	  (setq dummy_list (list))
	)
      )
      (if ok
	(setq dummy_list (cons data dummy_list))
      )
    )
    (setq fertig_list
	   (reverse (setq fertig_list
			   (cons (reverse dummy_list) fertig_list)
		    )
	   )
    )
  )

  (setq ent_data (entget ent_name))
  (setq p_list (list))
  (setq dummy_list (list))
  (setq ausricht (cdr (assoc 70 ent_data)))
  (setq offen (cdr (assoc 71 ent_data)))
  (setq punkte (cdr (assoc 72 ent_data)))
  (setq elemente (cdr (assoc 73 ent_data)))
  (setq punkte_list (liste_trennen ent_data 11))
  (setq nummer 1)

  (setq punkt (nth nr punkte_list))
  (setq p_x (cdr (assoc 11 punkt)))
  (setq richt_p (cdr (assoc 12 punkt)))
  (setq gehr_p (cdr (assoc 13 punkt)))
  (setq richt_w (angle (list 0.0 0.0 0.0) richt_p))
  (setq gehr_w (angle (list 0.0 0.0 0.0) gehr_p))
  (setq linien_list (liste_trennen punkt 74))
  (if (> (length linien_list) 2)
    (setq linien_list
	   (list (nth 0 linien_list) (last linien_list))
    )
  )
  (if (< nummer (length punkte_list))
    (progn
      (setq ende_list (list))
      (setq linie (nth 0 linien_list))
      (while (/= (car (nth 0 linie)) 41)
	(setq linie (cdr linie))
      )
      (setq abstand (cdr (nth 0 linie)))
      (setq anfang (cdr (nth 1 linie)))
      (setq p (polar p_x gehr_w abstand))
      (if (= nummer 1)
	(setq p (polar p richt_w anfang))
      )
      (setq p1 p)
      (if (nth 3 linie)
	(progn
	  (setq p (polar p_x gehr_w abstand))
	  (foreach dat_41 linie
	    (if	(= (car dat_41) 41)
	      (setq anfang (cdr dat_41))
	    )
	  )
	  (setq	ende_list
		 (cons (polar p richt_w anfang) ende_list)
	  )
	)
	(setq ende_list (cons nil ende_list))
      )
      (setq linie (nth 1 linien_list))
      (while (/= (car (nth 0 linie)) 41)
	(setq linie (cdr linie))
      )
      (setq abstand (cdr (nth 0 linie)))
      (setq anfang (cdr (nth 1 linie)))
      (setq p (polar p_x gehr_w abstand))
      (if (= nummer 1)
	(setq p (polar p richt_w anfang))
      )
      (setq p2 p)
      (if (nth 3 linie)
	(progn
	  (setq p (polar p_x gehr_w abstand))
	  (foreach dat_41 linie
	    (if	(= (car dat_41) 41)
	      (setq anfang (cdr dat_41))
	    )
	  )
	  (setq	ende_list
		 (cons (polar p richt_w anfang) ende_list)
	  )
	)
	(setq ende_list (cons nil ende_list))
      )
    )
    (progn
      (setq ende_list (reverse ende_list))
      (setq linie (nth 0 linien_list))
      (while (/= (car (nth 0 linie)) 41)
	(setq linie (cdr linie))
      )
      (setq abstand (cdr (nth 0 linie)))
      (setq anfang (cdr (nth 1 linie)))
      (if (<= (length linie) 2)
	(if (nth 0 ende_list)
	  (setq p (nth 0 ende_list))
	  (progn
	    (setq p (polar p_x gehr_w abstand))
	    (setq p (polar p richt_w anfang))
	  )
	)
	(progn
	  (foreach dat_41 linie
	    (if	(= (car dat_41) 41)
	      (setq anfang (cdr dat_41))
	    )
	  )
	  (setq p (polar p_x gehr_w abstand))
	  (setq p (polar p richt_w anfang))
	)
      )
      (setq p1 p)
      (setq ende_list (cdr ende_list))
      (setq linie (nth 1 linien_list))
      (while (/= (car (nth 0 linie)) 41)
	(setq linie (cdr linie))
      )
      (setq abstand (cdr (nth 0 linie)))
      (setq anfang (cdr (nth 1 linie)))
      (if (<= (length linie) 2)
	(if (nth 0 ende_list)
	  (setq p (nth 0 ende_list))
	  (progn
	    (setq p (polar p_x gehr_w abstand))
	    (setq p (polar p richt_w anfang))
	  )
	)
	(progn
	  (foreach dat_41 linie
	    (if	(= (car dat_41) 41)
	      (setq anfang (cdr dat_41))
	    )
	  )
	  (setq p (polar p_x gehr_w abstand))
	  (setq p (polar p richt_w anfang))
	)
      )
      (setq p2 p)
      (setq ende_list (cdr ende_list))
    )
  )
  (setq dummy (list p1 p2))
)

(defun k_3d->2d	(wert / dummy)
  (if (vl-every '(lambda (dummy) (= (type dummy) 'LIST)) wert)
    (mapcar '(lambda (dummy) (list (car dummy) (cadr dummy)))
	    wert
    )
    (list (car wert) (cadr wert))
  )
)

;;;---------------------------------------------------------------------------------

(defun c:k_m001	(/	    ent_name   ent_data	  ml_stil    def_data
		 def_name   beschr     ok	  filter     satz
		 mem_ml_list	       kill_list  dummy
		)

;;; Multilinienbeschreibung ndern
  (defun k_m001_enddlg (aktion)
    (setq ok aktion)
    (setq beschr (get_tile "beschr"))
    (done_dialog)
  )

  (setq ent_name (car (entsel)))
  (setq ent_data (entget ent_name))
  (setq ml_stil (cdr (assoc 2 ent_data)))
  (setq	def_data
	 (dictsearch
	   (cdr	(assoc -1
		       (dictsearch (namedobjdict) "ACAD_MLINESTYLE")
		)
	   )
	   ml_stil
	 )
  )
  (setq def_name (cdr (assoc -1 def_data)))
  (setq beschr (cdr (assoc 3 def_data)))
  (setq k_m001_dlg (load_dialog "k_Multilinien.dcl"))
  (if (not (new_dialog "k_m001" k_m001_dlg))
    (exit)
  )
  (action_tile "beschr" "(k_m001_enddlg 1)")
  (action_tile "accept" "(k_m001_enddlg 1)")
  (action_tile "cancel" "(k_m001_enddlg 0)")
  (set_tile "beschr" beschr)
  (mode_tile "beschr" 2)
  (start_dialog)
  (unload_dialog k_m001_dlg)
  (if (= ok 1)
    (progn
      (setq filter (list (cons 2 ml_stil)))
      (setq satz (ssget "x" filter))
      (setq mem_ml_list
	     (mapcar 'entget
		     (setq kill_list (k_satz->entlist satz))
	     )
      )
      (mapcar 'entdel kill_list)
      (print (cdr (assoc 3 def_data)))
      (princ " wird zu : ")
      (setq
	def_data (subst (cons 3 beschr) (assoc 3 def_data) def_data)
      )
      (entmod def_data)
      (setq
	dummy (member (cons 3 ml_stil)
		      (dictsearch (namedobjdict) "ACAD_MLINESTYLE")
	      )
      )
      (setq def_data
	     (dictsearch
	       (cdr
		 (assoc	-1
			(dictsearch (namedobjdict) "ACAD_MLINESTYLE")
		 )
	       )
	       ml_stil
	     )
      )
      (princ (cdr (assoc 3 def_data)))
      (princ)
      (mapcar 'entmake mem_ml_list)
    )
  )
  (princ)
)

(defun c:k_m002	(/ ML_OBJECT SATZ)
;;; Multilinen austauschen
  (setq satz (nth 1 (ssgetfirst)))
  (vla-startundomark (k_ac-doc))
  (if (null satz)
    (setq satz (ssget '((0 . "MLINE"))))
  )
  (setvar "cmdecho" 0)
  (print)
  (foreach obj_name (k_satz->objlist satz)
    (setq ml_object (vla-addmline
		      (vla-get-block (k_ac-layout nil))
		      (vla-get-coordinates obj_name)
		    )
    )
    (vla-put-Justification
      ml_object
      (vla-get-Justification obj_name)
    )
    (vla-put-layer ml_object (vla-get-layer obj_name))
;;;  (setq ent_name (entlast))
    (vla-delete obj_name)
  )
  (vla-endundomark (k_ac-doc))
)

(defun c:k_m003	(/ m_cmlstyle m_clayer satz)
;;; Multilinien in einzelne Abschnitte trennen
  (setq satz (nth 1 (ssgetfirst)))
  (vla-startundomark (k_ac-doc))
  (k_ofang "mem")
  (k_ofang "aus")
  (if (null satz)
    (setq satz (ssget '((0 . "MLINE"))))
  )

  (setq m_cmlstyle (getvar "cmlstyle"))
  (setq m_clayer (getvar "clayer"))
  (setq m_cmljust (getvar "cmljust"))
  (mapcar '(lambda (ent_name / ent_data p_list p)
	     (setq ent_data (entget ent_name))
	     (setvar "cmlstyle" (cdr (assoc 2 ent_data)))
	     (setvar "clayer" (cdr (assoc 8 ent_data)))
	     (setvar "cmljust" (cdr (assoc 70 ent_data)))
	     (setq p_list (list))
	     (while (setq p (assoc 11 ent_data))
	       (setq ent_data (cdr (member p ent_data)))
	       (setq p (cdr p))
	       (setq p_list (cons p p_list))
	     )
	     (setq p_list (reverse p_list))
	     (setq p 0)
	     (repeat (1- (length p_list))
	       (command "_.mline")
	       (command (trans (nth p p_list) 0 1))
	       (setq p (1+ p))
	       (command (trans (nth p p_list) 0 1))
	       (command "")
	     )
	     (entdel ent_name)
	   )
	  (k_satz->entlist satz)
  )
  (setvar "cmlstyle" m_cmlstyle)
  (setvar "clayer" m_clayer)
  (setvar "cmljust" m_cmljust)
  (k_ofang "restore")
  (vla-endundomark (k_ac-doc))
  (princ)
)

(defun c:k_m004	(/ satz lay_mem cml_mem cmlsc_mem cmlju_mem cmlst_mem)
;;; Multilinien umdrehen
  (setq satz (nth 1 (ssgetfirst)))
  (if (null satz)
    (setq satz (ssget '((0 . "MLINE"))))
  )
  (vla-startundomark (k_ac-doc))
  (foreach obj_name (k_satz->objlist satz)
    (vla-put-coordinates
      obj_name
      (k_liste->variant
	(apply 'append
	       (reverse
		 (gather (k_variant->list (vla-get-coordinates obj_name)) 3)
	       )
	)
	8197
      )
    )
    (vla-update obj_name)
  )
  (vla-endundomark (k_ac-doc))
  (princ)
)

(defun c:k_m005	(/ MEM_AUNITS SATZ SEGMENT_LIST W)
;;; Multilinien schraffieren
  (setq satz (nth 1 (ssgetfirst)))
  (vla-startundomark (k_ac-doc))
  (k_ofang "mem")
  (k_ofang "aus")
  (if (null satz)
    (setq satz (ssget '((0 . "MLINE"))))
  )
  (setvar "cmdecho" 0)
  (setq mem_aunits (getvar "aunits"))
  (setvar "aunits" 3)
  (foreach ent_name (k_satz->entlist satz)
    (setq segment_list (ml_segmentumrisse ent_name))
    (foreach p_list segment_list
      (setq w (angle (nth 0 p_list) (nth 1 p_list)))
;;;      (command "_.HATCH" "" "" w "" "")
;;;      (foreach p p_list
;;;	(command (trans p 0 1))
;;;      )
;;;      (command "_c" "")
      (k_plist->hatch p_list)
    )
  )
  (setvar "aunits" mem_aunits)
  (k_ofang "restore")
  (vla-endundomark (k_ac-doc))
  (setvar "cmdecho" 0)
  (princ)
)

(defun c:k_m007	()
;;; Enden von Multilinien ein- und ausschalten
  (defun k_m007_altpunkte ()
    (setq alt_p (list))
    (foreach data alt_data
      (if (= (car data) 11)
	(setq alt_p (cons (cdr data) alt_p))
      )
    )
  )

  (defun k_m007_neupunkte ()
    (setq neu_p (list))
    (foreach data neu_data
      (if (= (car data) 11)
	(setq neu_p (cons (cdr data) neu_p))
      )
    )
  )

  (setvar "cmdecho" 0)
  (setq pic (entsel))
  (setq ent_name (car pic))
  (setq p1 (nth 1 pic))
  (vla-startundomark (k_ac-doc))
  (setq alt_data (entget ent_name))
  (command "_.MLEDIT" "_AV" p1 "")
  (setq neu_data (entget ent_name))
  (k_m007_altpunkte)
  (k_m007_neupunkte)
  (foreach p neu_p
    (if	(not (member p alt_p))
      (setq neupunkt p)
    )
  )
  (setq ent_data alt_data)
  (if (> (distance neupunkt (nth 0 alt_p))
	 (distance neupunkt (nth 0 (reverse alt_p)))
      )
    (cond
      ((= (cdr (assoc 71 ent_data)) 1)
       (setq ent_data (subst (cons 71 5) (assoc 71 ent_data) ent_data))
      )
      ((= (cdr (assoc 71 ent_data)) 5)
       (setq ent_data (subst (cons 71 1) (assoc 71 ent_data) ent_data))
      )
      ((= (cdr (assoc 71 ent_data)) 9)
       (setq ent_data (subst (cons 71 13) (assoc 71 ent_data) ent_data))
      )
      ((= (cdr (assoc 71 ent_data)) 13)
       (setq ent_data (subst (cons 71 9) (assoc 71 ent_data) ent_data))
      )
    )
    (cond
      ((= (cdr (assoc 71 ent_data)) 1)
       (setq ent_data (subst (cons 71 9) (assoc 71 ent_data) ent_data))
      )
      ((= (cdr (assoc 71 ent_data)) 5)
       (setq ent_data (subst (cons 71 13) (assoc 71 ent_data) ent_data))
      )
      ((= (cdr (assoc 71 ent_data)) 9)
       (setq ent_data (subst (cons 71 1) (assoc 71 ent_data) ent_data))
      )
      ((= (cdr (assoc 71 ent_data)) 13)
       (setq ent_data (subst (cons 71 5) (assoc 71 ent_data) ent_data))
      )
    )
  )
  (entmod ent_data)
  (entupd ent_name)
)

(defun c:k_m008	()
;;; Abschnitt von Multiline herrausziehen
  (defun k_m008_altpunkte ()
    (setq alt_p (list))
    (foreach data alt_data
      (if (= (car data) 11)
	(setq alt_p (cons (cdr data) alt_p))
      )
    )
  )

  (defun k_m008_neupunkte ()
    (setq neu_p (list))
    (foreach data neu_data
      (if (= (car data) 11)
	(setq neu_p (cons (cdr data) neu_p))
      )
    )
  )

  (setvar "cmdecho" 0)
;;; (command "_ucs" "l" "ml_zieh")
;;; (command "_ucs" "sp" "ml_zieh")
;;; (command "_ucs" "_w")
  (setq mem_snapang (getvar "snapang"))
  (setq ok nil)
  (setq pic (entsel))
  (setq ent_name (car pic))
  (setq p1 (nth 1 pic))
  (setq pic (entsel))
  (if (equal ent_name (car pic))
    (progn
      (setq ent_name (car pic))
      (setq p2 (nth 1 pic))
      (vla-startundomark (k_ac-doc))
      (setq alt_data (entget ent_name))
      (setq min_b 0)
      (setq max_b 0)
      (foreach data alt_data
	(if (= (car data) 41)
	  (progn
	    (setq min_b (min min_b (cdr data)))
	    (setq max_b (max max_b (cdr data)))
	  )
	)
      )
      (setq breite (abs (- max_b min_b)))
      (command "_.MLEDIT" "_AV" p1 "")
      (command "_.MLEDIT" "_AV" p2 "")
      (setq neu_data (entget ent_name))
      (k_m008_altpunkte)
      (k_m008_neupunkte)
      (setq n 0)
      (while (equal (nth n alt_p) (nth n neu_p))
	(setq alt_p (cdr alt_p))
	(setq neu_p (cdr neu_p))
      )
      (setq p2 (car neu_p))
      (setq neu_p (cdr neu_p))
      (setq p1 (car neu_p))
      (setq neu_p (cdr neu_p))
      (if (not (equal alt_p neu_p))
	(progn
	  (entmod alt_data)
	  (print "gewhlte Punkte nicht auf gleichem Segment")
	)
	(progn
	  (setq w (- (angle p1 p2) (/ pi 2.0)))
	  (if (minusp w)
	    (setq w (+ w (* pi 2.0)))
	  )
	  (setvar "snapang" w)
	  (setq dummy1_list (list))
	  (setq p0 (mapcar '(lambda (x1 x2) (/ (+ x1 x2) 2)) p1 p2))
	  (setq p01 (mapcar '(lambda (x1 x2) (/ (+ x1 x2) 2)) p0 p1))
	  (setq p02 (mapcar '(lambda (x1 x2) (/ (+ x1 x2) 2)) p0 p2))
	  (setq dummy01_list (list (cons 11 p01)))
	  (setq dummy02_list (list (cons 11 p02)))
	  (setq dummy2 nil)
	  (foreach data	neu_data
	    (if	(= (car data) 11)
	      (progn
		(if (equal (cdr data) p1)
		  (progn
		    (setq dummy2 t)
		  )
		)
		(if (equal (cdr data) p2)
		  (progn
		    (setq dummy2 nil)
		    (setq dummy1_list
			   (append dummy02_list
				   dummy01_list
				   dummy1_list
			   )
		    )
		  )
		)
	      )
	      (progn
		(if dummy2
		  (progn
		    (setq dummy01_list (cons data dummy01_list))
		    (setq dummy02_list (cons data dummy02_list))
		  )
		)
	      )
	    )
	    (setq dummy1_list (cons data dummy1_list))
	  )
	  (setq ent_data (reverse dummy1_list))
	  (setq
	    ent_data (subst (cons 72 (+ (cdr (assoc 72 ent_data)) 2))
			    (assoc 72 ent_data)
			    ent_data
		     )
	  )
	  (entmod ent_data)
	  (command "_.stretch"
		   "_c"
		   (polar p01 w (/ breite 2.0))
		   (polar p01 w (/ breite -2.0))
		   ""
		   p01
		   (polar p1 w breite)
	  )
	  (command "_.stretch"
		   "_c"
		   (polar p02 w (/ breite 2.0))
		   (polar p02 w (/ breite -2.0))
		   ""
		   p02
		   (polar p2 w breite)
	  )
	  (command "_.stretch"
		   "_c"
		   (polar p1 w breite)
		   (polar p2 w breite)
		   ""
		   (polar p2 w breite)
		   "\\"
	  )
	  (setq ent_data (entget ent_name))
	)
      )
      (vla-endundomark (k_ac-doc))
      (command "_.undo" "")
      (setq ok t)
    )
    (print "zweiter Punkt nicht auf Objekt")
  )
  (if ok
    (progn
      (vla-startundomark (k_ac-doc))
      (entmod ent_data)
;;; (command "_ucs" "ho" "ml_zieh")
;;; (command "_ucs" "l" "ml_zieh")
      (vla-endundomark (k_ac-doc))
      (setvar "cmdecho" 0)
    )
  )
  (princ)
)

(defun c:k_m009	()
;;; Multilinie brechen
  (defun k_m009_altpunkte ()
    (setq alt_p (list))
    (foreach data alt_data
      (if (= (car data) 11)
	(setq alt_p (cons (cdr data) alt_p))
      )
    )
  )

  (defun k_m009_neupunkte ()
    (setq neu_p (list))
    (foreach data neu_data
      (if (= (car data) 11)
	(setq neu_p (cons (cdr data) neu_p))
      )
    )
  )

  (setvar "cmdecho" 0)
  (setq pic (entsel))
  (setq ent_name (car pic))
  (setq p1 (nth 1 pic))
  (setq pic (entsel))
  (if pic
    (progn
      (if (equal ent_name (car pic))
	(progn
	  (setq ent_name (car pic))
	  (setq p2 (nth 1 pic))
	  (vla-startundomark (k_ac-doc))
	  (setq alt_data (entget ent_name))
	  (setq exdat (assoc -3 alt_data))
	  (command "-mledit" "kh" p1 "")
	  (command "-mledit" "kh" p2 "")
	  (setq neu_data (entget ent_name))
	  (k_m009_altpunkte)
	  (k_m009_neupunkte)
	  (setq n 0)
	  (while (equal (nth n alt_p) (nth n neu_p))
	    (setq alt_p (cdr alt_p))
	    (setq neu_p (cdr neu_p))
	  )
	  (setq p2 (car neu_p))
	  (setq neu_p (cdr neu_p))
	  (setq p1 (car neu_p))
	  (setq neu_p (cdr neu_p))
	  (if (not (equal alt_p neu_p))
	    (progn
	      (entmod alt_data)
	      (print "gewhlte Punkte nicht auf gleichem Segment")
	    )
	    (progn
	      (setq n 0)
	      (setq dummy (list))
	      (while (/= (car (nth n neu_data)) 11)
		(setq dummy (cons (nth n neu_data) dummy))
		(setq n (1+ n))
	      )
	      (setq dummy_list1
		     (append (reverse dummy)
			     (member (cons 11 p2) neu_data)
		     )
	      )
	      (setq n 0)
	      (foreach data dummy_list1
		(if (= (car data) 11)
		  (setq n (1+ n))
		)
	      )
	      (setq dummy_list1
		     (subst (cons 72 n)
			    (assoc 72 dummy_list1)
			    dummy_list1
		     )
	      )
	      (entmod dummy_list1)
	      (princ)
	      (setq ok 2)
	      (setq n 0)
	      (setq m 0)
	      (setq z 0)
	      (setq dummy_list1 (list))
	      (while (/= ok 0)
		(if (/= (car (nth n neu_data)) -1)
		  (progn
		    (if	(= (car (nth n neu_data)) 11)
		      (progn
			(if (or	(equal (cdr (nth n neu_data)) p1)
				(equal (cdr (nth n neu_data)) p2)
			    )
			  (setq ok (1- ok))
			)
			(setq m (1+ m))
		      )
		    )
		    (if	(/= ok 0)
		      (setq dummy_list1
			     (cons (nth n neu_data) dummy_list1)
		      )
		    )
		  )
		)
		(setq n (1+ n))
	      )

	      (if exdat
		(setq dummy_list1 (cons exdat dummy_list1))
	      )
	      (setq dummy_list1 (reverse dummy_list1))
	      (setq dummy_list1
		     (subst (cons 72 (1- m))
			    (assoc 72 dummy_list1)
			    dummy_list1
		     )
	      )
	      (entmake dummy_list1)
	    )
	  )
	  (vla-endundomark (k_ac-doc))
	)
	(print "zweiter Punkt nicht auf Objekt")
      )
    )

    (progn
      (setq p2 p1)
      (vla-startundomark (k_ac-doc))
      (setq alt_data (entget ent_name))
      (setq exdat (assoc -3 alt_data))
      (command "-mledit" "kh" p1 "")
      (setq neu_data (entget ent_name))
      (k_m009_altpunkte)
      (k_m009_neupunkte)
      (setq n 0)
      (while (equal (nth n alt_p) (nth n neu_p))
	(setq alt_p (cdr alt_p))
	(setq neu_p (cdr neu_p))
      )
      (setq p2 (car neu_p))
      (setq p1 (car neu_p))

      (setq n 0)
      (setq dummy (list))
      (while (/= (car (nth n neu_data)) 11)
	(setq dummy (cons (nth n neu_data) dummy))
	(setq n (1+ n))
      )
      (setq dummy_list1
	     (append (reverse dummy)
		     (member (cons 11 p2) neu_data)
	     )
      )
      (setq n 0)
      (foreach data dummy_list1
	(if (= (car data) 11)
	  (setq n (1+ n))
	)
      )
      (setq dummy_list1
	     (subst (cons 72 n)
		    (assoc 72 dummy_list1)
		    dummy_list1
	     )
      )
      (entmod dummy_list1)
      (princ)
      (setq ok 2)
      (setq n 0)
      (setq m 0)
      (setq z 0)
      (setq dummy_list1 (list))
      (while (and (/= ok 0) (nth n neu_data))
	(if (/= (car (nth n neu_data)) -1)
	  (progn
	    (if	(= (car (nth n neu_data)) 11)
	      (progn
		(if (= ok 1)
		  (setq ok 0)
		)
		(if (or	(equal (cdr (nth n neu_data)) p1)
			(equal (cdr (nth n neu_data)) p2)
		    )
		  (setq ok (1- ok))
		)
		(setq m (1+ m))
	      )
	    )
	    (if	(/= ok 0)
	      (setq dummy_list1 (cons (nth n neu_data) dummy_list1))
	    )
	  )
	)
	(setq n (1+ n))
      )

      (if exdat
	(setq dummy_list1 (cons exdat dummy_list1))
      )
      (setq dummy_list1 (reverse dummy_list1))
      (setq dummy_list1
	     (subst (cons 72 (1- m))
		    (assoc 72 dummy_list1)
		    dummy_list1
	     )
      )
      (entmake dummy_list1)
      (vla-endundomark (k_ac-doc))
    )
  )
  (setvar "cmdecho" 0)
  (princ)
)

(defun c:k_m010	()
;;; Multilinienausrichtung ndern
  (setq satz (nth 1 (ssgetfirst)))
  (vla-startundomark (k_ac-doc))
  (if (null satz)
    (setq satz (ssget '((0 . "MLINE"))))
  )

  (setq lay_mem (getvar "clayer"))
  (setq os_mem (getvar "osmode"))
  (setq ml_mem (getvar "cmlstyle"))
  (setvar "osmode" 0)

  (if satz
    (progn
      (setq n (1- (sslength satz)))
      (print)
      (repeat (sslength satz)
	(princ "\r")
	(princ n)
	(princ "  ")
	(setq ent_name (ssname satz n))
	(setq ent_data (entget ent_name))
	(setq mljust (cdr (assoc 70 ent_data)))
	(if (/= mljust (getvar "cmljust"))
	  (progn
	    (setq exdat (assoc -3 ent_data))
	    (setq mllay (cdr (assoc 8 ent_data)))
	    (setq mlscale (cdr (assoc 40 ent_data)))
	    (setq mlart (cdr (assoc 2 ent_data)))
	    (setq p_max_list (list))
	    (setq p_min_list (list))
	    (setq stil_data (entget (cdr (assoc 340 ent_data))))
	    (setq d_max (cdr (assoc 49 stil_data)))
	    (setq d_min d_max)
	    (setq d_list (list))
	    (foreach e stil_data
	      (if (= (car e) 49)
		(progn
		  (setq d_max (max (cdr e) d_max))
		  (setq d_min (min (cdr e) d_min))
		  (setq d_list (cons (cdr e) d_list))
		)
	      )
	    )
	    (setq a_n 0)
	    (setq abst 0)
	    (repeat (1- (length d_list))
	      (setq
		dummy (abs (- (nth a_n d_list) (nth (1+ a_n) d_list)))
	      )
	      (if (> dummy abst)
		(progn
		  (setq abst dummy)
		  (setq	t_posy
			 (/ (+ (nth a_n d_list) (nth (1+ a_n) d_list))
			    2
			 )
		  )
		)
	      )
	      (setq a_n (1+ a_n))
	    )
	    (setq d_max (* d_max (cdr (assoc 40 ent_data))))
	    (setq d_min (* d_min (cdr (assoc 40 ent_data))))
	    (setq d_0 (/ (+ d_min d_max) 2))
	    (setq a_min (- d_min d_0))
	    (setq a_max (- d_max d_0))
	    (cond
	      ((= mljust 0)
	       (setq d_min (- d_min a_max))
	       (setq d_max (- d_max a_max))
	      )
	      ((= mljust 1)
	       (setq ok 1)
	      )
	      ((= mljust 2)
	       (setq d_min (+ d_min a_max))
	       (setq d_max (+ d_max a_max))
	      )
	    )
	    (setq p_max_list (list))
	    (setq p_min_list (list))
	    (setq stil_data (entget (cdr (assoc 340 ent_data))))
	    (setq d_max (cdr (assoc 49 stil_data)))
	    (setq d_min d_max)
	    (setq d_list (list))
	    (foreach e stil_data
	      (if (= (car e) 49)
		(progn
		  (setq d_max (max (cdr e) d_max))
		  (setq d_min (min (cdr e) d_min))
		  (setq d_list (cons (cdr e) d_list))
		)
	      )
	    )
	    (setq a_n 0)
	    (setq abst 0)
	    (repeat (1- (length d_list))
	      (setq
		dummy (abs (- (nth a_n d_list) (nth (1+ a_n) d_list)))
	      )
	      (if (> dummy abst)
		(progn
		  (setq abst dummy)
		  (setq	t_posy
			 (/ (+ (nth a_n d_list) (nth (1+ a_n) d_list))
			    2
			 )
		  )
		)
	      )
	      (setq a_n (1+ a_n))
	    )
	    (setq d_max (* d_max (cdr (assoc 40 ent_data))))
	    (setq d_min (* d_min (cdr (assoc 40 ent_data))))
	    (setq d_0 (/ (+ d_min d_max) 2))
	    (setq a_min (- d_min d_0))
	    (setq a_max (- d_max d_0))
	    (cond
	      ((= mljust 0)
	       (setq d_min (- d_min a_max))
	       (setq d_max (- d_max a_max))
	      )
	      ((= mljust 1)
	       (setq ok 1)
	      )
	      ((= mljust 2)
	       (setq d_min (+ d_min a_max))
	       (setq d_max (+ d_max a_max))
	      )
	    )
	    (setq p_max_list (list))
	    (setq p_mid_list (list))

	    (setq p_min_list (list))
	    (setq stil_data (entget (cdr (assoc 340 ent_data))))
	    (setq d_max (cdr (assoc 49 stil_data)))
	    (setq d_min d_max)
	    (setq d_list (list))
	    (foreach e stil_data
	      (if (= (car e) 49)
		(progn
		  (setq d_max (max (cdr e) d_max))
		  (setq d_min (min (cdr e) d_min))
		  (setq d_list (cons (cdr e) d_list))
		)
	      )
	    )
	    (setq a_n 0)
	    (setq abst 0)
	    (repeat (1- (length d_list))
	      (setq
		dummy (abs (- (nth a_n d_list) (nth (1+ a_n) d_list)))
	      )
	      (if (> dummy abst)
		(progn
		  (setq abst dummy)
		  (setq	t_posy
			 (/ (+ (nth a_n d_list) (nth (1+ a_n) d_list))
			    2
			 )
		  )
		)
	      )
	      (setq a_n (1+ a_n))
	    )
	    (setq d_max (* d_max (cdr (assoc 40 ent_data))))
	    (setq d_min (* d_min (cdr (assoc 40 ent_data))))
	    (setq d_0 (/ (+ d_min d_max) 2))
	    (setq a_min (- d_min d_0))
	    (setq a_max (- d_max d_0))
	    (cond
	      ((= mljust 0)
	       (setq d_min (- d_min a_max))
	       (setq d_max (- d_max a_max))
	      )
	      ((= mljust 1)
	       (setq ok 1)
	      )
	      ((= mljust 2)
	       (setq d_min (+ d_min a_max))
	       (setq d_max (+ d_max a_max))
	      )
	    )
	    (while (setq p (assoc 11 ent_data))
	      (setq ent_data (cdr (member p ent_data)))
	      (setq p (cdr p))
	      (setq pr (mapcar '+ p (cdr (assoc 12 ent_data))))
	      (setq pg (mapcar '+ p (cdr (assoc 13 ent_data))))
	      (setq wr (angle p pr))
	      (setq wg_max (angle p pg))
	      (if (< wg_max pi)
		(setq wg_min (+ wg_max pi))
		(setq wg_min (- wg_max pi))
	      )
	      (setq w (- wr wg_max))
	      (setq w (- (* 2 pi) w))
	      (setq h_max (abs (/ d_max (sin w))))
	      (setq p_max (polar p wg_max h_max))
	      (setq p_max_list (cons p_max p_max_list))
	      (setq h_min (abs (/ d_min (sin w))))
	      (setq p_min (polar p wg_min h_min))
	      (setq p_min_list (cons p_min p_min_list))
	      (setq p_mid_list
		     (cons
		       (mapcar '(lambda (x1 x2) (/ (+ x1 x2) 2))
			       p_min
			       p_max
		       )
		       p_mid_list
		     )
	      )
	    )
	    (setq p_max_list (reverse p_max_list))
	    (setq p_mid_list (reverse p_mid_list))
	    (setq p_min_list (reverse p_min_list))
	    (cond
	      ((= (getvar "cmljust") 0)
	       (setq p_list p_max_list)
	      )
	      ((= (getvar "cmljust") 1)
	       (setq p_list p_mid_list)
	      )
	      ((= (getvar "cmljust") 2)
	       (setq p_list p_min_list)
	      )
	      (t nil)
	    )
	    (setvar "clayer" mllay)
	    (setvar "cecolor" "256")
	    (setvar "cmlstyle" mlart)
	    (setvar "cmlscale" mlscale)
	    (setvar "cmdecho" 0)
	    (entdel ent_name)
	    (command "_mline")
	    (setq cmd_mem (getvar "cmdactive"))
	    (foreach p p_list
	      (command (trans p 0 1))
	    )
	    (while (= (getvar "cmdactive") cmd_mem) (command ""))
	    (if	exdat
	      (progn
		(setq ent_name (entlast))
		(setq ent_data (reverse (entget ent_name)))
		(setq ent_data (reverse (cons exdat ent_data)))
		(entmod ent_data)
	      )
	    )
	  )
	)
	(setq n (1- n))
      )
    )
  )
  (setvar "cmlstyle" ml_mem)
  (setvar "osmode" os_mem)
  (vla-endundomark (k_ac-doc))
  (setvar "cmdecho" 0)
)

(defun c:k_m011	()
;;; Multilinien strecken ohne Winkelnderung
  (defun m011_mk_plist (ent_data / p_list)
    (setq p_list (list))
    (foreach dat ent_data
      (if (= (car dat) 11)
	(setq p1 (cdr dat))
      )
      (if (= (car dat) 12)
	(progn
	  (setq p2 (mapcar '+ p1 (cdr dat)))
	  (setq p_list (cons (list p1 p2) p_list))
	)
      )
    )
    (setq p_list (reverse p_list))
  )
  (vla-startundomark (k_ac-doc))
  (setvar "cmdecho" 0)
  (command "_stretch")
  (setq cmd_mem (getvar "cmdactive"))
  (while (= (getvar "cmdactive") cmd_mem) (command "\\"))
  (vla-endundomark (k_ac-doc))
  (setq satz (ssget "_p" '((0 . "MLINE"))))
  (if satz
    (progn
      (setq n 0)
      (setq data_list_neu (list))
      (repeat (sslength satz)
	(setq ent_name (ssname satz n))
	(setq ent_data (entget ent_name))
	(setq data_list_neu (cons ent_data data_list_neu))
	(setq n (1+ n))
      )
      (command "z")
      (setq n 0)
      (setq data_list_alt (list))
      (repeat (sslength satz)
	(setq ent_name (ssname satz n))
	(setq ent_data (entget ent_name))
	(setq data_list_alt (cons ent_data data_list_alt))
	(setq n (1+ n))
      )
      (mk_angle_korr data_list_alt data_list_neu)
    )
  )
  (setvar "cmdecho" 0)
  (vla-endundomark (k_ac-doc))
  (princ)
)

(defun c:k_m012	()
;;; Multilinien sprengen
  (setq satz (nth 1 (ssgetfirst)))
  (vla-startundomark (k_ac-doc))
  (if (null satz)
    (setq satz (ssget '((0 . "MLINE"))))
  )

  (vla-startundomark (k_ac-doc))
  (setvar "cmdecho" 0)
  (if satz
    (progn
      (setq n 0)
      (repeat (sslength satz)
	(setq ent_name (ssname satz n))
	(setq ent_data (entget ent_name))
	(setq ent_scale (cdr (assoc 48 ent_data)))
	(command "_explode" ent_name)
	(if ent_scale
	  (command "ndern" "v" "" "ei" "ltf" ent_scale "")
	)
	(setq n (1+ n))
      )
    )
  )
  (vla-endundomark (k_ac-doc))
  (setvar "cmdecho" 0)
)

(defun c:k_m013	()
;;; Multilinie aus Polylinie erstellen
  (setvar "cmdecho" 0)
  (vla-startundomark (k_ac-doc))
  (setq w_max (* (/ 1 180.0) pi))
  (setq f nil)
  (setq satz (ssget '((0 . "LWPOLYLINE"))))
  (if satz
    (progn
      (setq os (getvar "osmode"))
      (setvar "osmode" 0)
      (setq n (1- (sslength satz)))
      (print)
      (repeat (sslength satz)
	(princ "\r")
	(princ n)
	(princ "  ")
	(setq ent_data (entget (setq ent_name (ssname satz n))))
	(setq p_list (pline->p_list ent_data))
	(command "_mline")
	(foreach p p_list
	  (command p)
	)
	(if (= (rem (cdr (assoc 70 ent_data)) 2) 1)
	  (command "s")
	)
	(while (= (getvar "cmdactive") 1) (command ""))
	(entdel ent_name)
	(setq n (1- n))
      )
      (setvar "osmode" os)
    )
  )
  (vla-endundomark (k_ac-doc))
  (setvar "cmdecho" 0)
)

(defun c:k_m014	()
;;; Polylinie aus Multilinie erstellen
  (setvar "cmdecho" 0)
  (vla-startundomark (k_ac-doc))
  (setq satz (ssget '((0 . "MLINE"))))
  (if satz
    (progn
      (setq os (getvar "osmode"))
      (setvar "osmode" 0)
      (setq n (1- (sslength satz)))
      (setq bogen f)
      (repeat (sslength satz)
	(princ "\r")
	(princ n)
	(princ "  ")
	(setq ent_data (entget (setq ent_name (ssname satz n))))
	(setvar "clayer" (cdr (assoc 8 ent_data)))
	(setq p_list (list))
	(foreach dat ent_data
	  (if (= (car dat) 11)
	    (progn
	      (if bogen
		(rechne_bogen (car p_list) (cdr dat))
	      )
	      (setq p_list (cons (cdr dat) p_list))
	      (setq bogen f)
	    )
	  )
	)
	(setq p_list (reverse p_list))
	(command "_pline")
	(foreach p p_list
	  (command p)
	)
	(if (= (cdr (assoc 71 ent_data)) 3)
	  (command "s")
	)
	(while (= (getvar "cmdactive") 1) (command ""))
	(entdel ent_name)
	(setq n (1- n))
      )
      (setvar "osmode" os)
    )
  )
  (vla-endundomark (k_ac-doc))
  (setvar "cmdecho" 0)
)

(defun c:k_m018	(/	   dict_data ml_dict   ml_list	 ml
		 k_m018_id ok	     filter    satz	 ent_name
		 ent_data  n	     alt_name  ml_bez
		)
;;; Multilinientypen zusammenfassen
  (defun m018_enddlg (wert)
    (setq ok wert)
    (done_dialog wert)
  )

  (defun m018_altname ()
    (setq alt_name (nth (atoi (get_tile "altname")) ml_lst))
    (set_tile "alt_bez"
	      (cdr
		(assoc 3 (dictsearch (cdr (assoc -1 ml_dict)) alt_name))
	      )
    )
  )

  (defun m018_neuname ()
    (setq neu_name (nth (atoi (get_tile "neuname")) ml_lst))
    (set_tile "neu_bez"
	      (cdr
		(assoc 3 (dictsearch (cdr (assoc -1 ml_dict)) neu_name))
	      )
    )
  )

  (setq dict_data (entget (namedobjdict)))
  (if (setq ml_dict (member '(3 . "ACAD_MLINESTYLE") dict_data))
    (progn
      (setq ml_dict (entget (cdr (assoc 350 ml_dict))))
      (setq ml_list (list))
      (setq ml_lst (list))
      (foreach ml ml_dict
	(if (= (car ml) 3)
	  (setq ml_bez (cdr ml))
	)
	(if (= (car ml) 350)
	  (progn
	    (setq ml_list (cons (list ml_bez (cdr ml)) ml_list))
	    (setq ml_lst (cons ml_bez ml_lst))
	  )
	)
      )
      (setq k_m018_id (load_dialog "k_Multilinien.dcl"))
      (if (not (new_dialog "k_m018" k_m018_id))
	(exit)
      )
      (action_tile "altname" "(m018_altname)")
      (action_tile "neuname" "(m018_neuname)")
      (action_tile "accept" "(m018_enddlg '1)")
      (action_tile "cancel" "(m018_enddlg '0)")
      (start_list "altname")
      (mapcar 'add_list ml_lst)
      (end_list)
      (start_list "neuname")
      (mapcar 'add_list ml_lst)
      (end_list)
      (start_dialog)
      (unload_dialog k_m018_id)
      (if (= ok 1)
	(progn
	  (setq filter (list (cons 0 "MLINE") (cons 2 alt_name)))
	  (setq satz (ssget "x" filter))
	  (if satz
	    (progn
	      (setvar "cmdecho" 0)
	      (setq n (1- (sslength satz)))
	      (repeat (sslength satz)
		(princ (strcat "\r" (itoa n) "  "))
		(setq ent_name (ssname satz n))
		(setq ent_data (entget ent_name))
		(setq ent_data (subst (cons 2 neu_name)
				      (assoc 2 ent_data)
				      ent_data
			       )
		)
		(setq ent_data
		       (subst
			 (cons 340 (nth 1 (assoc neu_name ml_list)))
			 (assoc 340 ent_data)
			 ent_data
		       )
		)
		(entdel ent_name)
		(entmake ent_data)
		(setq n (1- n))
	      )
	      (setvar "cmdecho" 0)
	      (command "_purge" "Ml" alt_name "n")
	    )
	  )
	)
      )
    )
  )
  (princ)
)

(defun c:k_m019	()
;;; Multilinienlnge
  (setq gesamt 0.0)
  (setq laenge 0.0)
  (setq satz (ssget '((0 . "MLINE"))))
  (if satz
    (progn
      (setq gesamt 0.0)
      (setq n 0)
      (repeat (sslength satz)
	(setq laenge 0.0)
	(setq ent_name (ssname satz n))
	(setq ent_data (entget ent_name))
	(setq px (cdr (assoc 10 ent_data)))
	(foreach data ent_data
	  (if (= (car data) 11)
	    (progn
	      (setq laenge (+ laenge (distance px (cdr data))))
	      (setq px (cdr data))
	    )
	  )
	)
	(print laenge)
	(setq gesamt (+ gesamt laenge))
	(setq n (1+ n))
      )
    )
  )
  (print gesamt)
  (princ)
)

(defun c:k_m020	()
;;; Multilinien versetzen
  (vla-startundomark (k_ac-doc))
  (k_ofang "mem")
  (k_ofang "aus")
  (setq abst (getdist "Abstand : "))
  (setq pic (entsel))
  (setq ent_name (car pic))
  (setq ent_data (entget ent_name))
  (while (= (cdr (assoc 0 ent_data)) "MLINE")
    (setq px (getpoint))
    (setq p_list (list))
    (setvar "cmlstyle" (cdr (assoc 2 ent_data)))
    (setvar "cmljust" (cdr (assoc 70 ent_data)))
    (setvar "cmlscale" (cdr (assoc 40 ent_data)))
    (setvar "clayer" (cdr (assoc 8 ent_data)))
    (foreach data ent_data
      (if (= (car data) 11)
	(progn
	  (setq p_list (cons (cdr data) p_list))
	)
      )
    )
    (command "_pline")
    (foreach p (reverse p_list)
      (command p)
    )
    (command "")
    (setq tmp_name (entlast))
    (command "_offset" abst tmp_name px "")
    (entdel tmp_name)
    (setvar "cmdecho" 0)
    (setq w_max (* (/ 5 180.0) pi))
    (setq f nil)
    (setq os (getvar "osmode"))
    (setvar "osmode" 0)
    (setq bogen f)
    (setq ent_data (entget (setq ent_name (entlast))))
    (setq p_list (list))
    (setq bogen f)
    (foreach dat ent_data
      (if (= (car dat) 10)
	(progn
	  (if bogen
	    (rechne_bogen (car p_list) (cdr dat))
	  )
	  (setq p_list (cons (cdr dat) p_list))
	  (setq bogen f)
	)
      )
      (if (= (car dat) 42)
	(progn
	  (if (/= (cdr dat) 0)
	    (setq bogen (cdr dat))
	    (setq bogen f)
	  )
	)
      )
    )
    (if	(= (rem (cdr (assoc 70 ent_data)) 2) 1)
      (if bogen
	(rechne_bogen (car p_list) (car (reverse p_list)))
      )
    )
    (setq p_list (reverse p_list))
    (command "_mline")
    (foreach p p_list
      (command p)
    )
    (if	(= (rem (cdr (assoc 70 ent_data)) 2) 1)
      (command "s")
    )
    (while (= (getvar "cmdactive") 1) (command ""))
    (entdel ent_name)
    (setvar "osmode" os)
    (setvar "cmdecho" 0)
    (setq pic (entsel))
    (setq ent_name (car pic))
    (setq ent_data (entget ent_name))
  )
  (k_ofang "restore")
  (vla-endundomark (k_ac-doc))
  (princ)
)

(defun c:k_m021	()
;;; Multilinienabschnitt verschieben
  (defun m021_altpunkte	()
    (setq alt_p (list))
    (foreach data alt_data
      (if (= (car data) 11)
	(setq alt_p (cons (cdr data) alt_p))
      )
    )
  )

  (defun m021_neupunkte	()
    (setq neu_p (list))
    (foreach data neu_data
      (if (= (car data) 11)
	(setq neu_p (cons (cdr data) neu_p))
      )
    )
  )

  (setq mem_snapang (getvar "snapang"))
  (setq pic (entsel))
  (if pic
    (get_snapang_pickent pic)
    (setq pic (entsel))
  )

  (setq ent_name (nth 0 pic))
  (setq ent_data (entget ent_name))
  (if (= (cdr (assoc 0 ent_data)) "MLINE")
    (progn
      (setq px (nth 1 pic))
      (vla-startundomark (k_ac-doc))
      (setq alt_data (entget ent_name))
      (setq exdat (assoc -3 alt_data))
      (command "-mledit" "kh" px "")
      (setq neu_data (entget ent_name))
      (m021_altpunkte)
      (m021_neupunkte)
      (setq alt_p (reverse alt_p))
      (setq neu_p (reverse neu_p))
      (print alt_p)
      (print neu_p)
      (setq n 0)
      (while (equal (nth n alt_p) (nth n neu_p))
	(setq n (1+ n))
      )
      (setq p1 (ml_ecken ent_name (1- n)))
      (setq p2 (ml_ecken ent_name (1+ n)))
      (entmod ent_data)
      (setq px1	(polar (nth 0 p1)
		       (angle (nth 1 p2) (nth 0 p1))
		       (distance (nth 0 p1) (nth 1 p1))
		)
      )
      (setq px2	(polar (nth 1 p1)
		       (angle (nth 0 p2) (nth 1 p1))
		       (distance (nth 1 p1) (nth 0 p1))
		)
      )
      (setq px4	(polar (nth 0 p2)
		       (angle (nth 1 p1) (nth 0 p2))
		       (distance (nth 0 p2) (nth 1 p2))
		)
      )
      (setq px3	(polar (nth 1 p2)
		       (angle (nth 0 p1) (nth 1 p2))
		       (distance (nth 1 p2) (nth 0 p2))
		)
      )
      (vla-startundomark (k_ac-doc))

      (setq minp
	     (list (min (nth 0 px1) (nth 0 px2) (nth 0 px3) (nth 0 px4))
		   (min (nth 1 px1) (nth 1 px2) (nth 1 px3) (nth 1 px4))
	     )
      )
      (setq maxp
	     (list (max (nth 0 px1) (nth 0 px2) (nth 0 px3) (nth 0 px4))
		   (max (nth 1 px1) (nth 1 px2) (nth 1 px3) (nth 1 px4))
	     )
      )
      (command "_zoom" minp maxp)
      (command "_stretch" "kp" px1 px2 px3 px4 "" "")
;;; (command "'_zoom" "_p")
      (setq cmd_mem (getvar "cmdactive"))
      (while (= (getvar "cmdactive") cmd_mem) (command "\\"))
      (vla-endundomark (k_ac-doc))
      (setq satz (ssadd ent_name))
      (setq n 0)
      (setq data_list_neu (list))
      (repeat (sslength satz)
	(setq ent_name (ssname satz n))
	(setq ent_data (entget ent_name))
	(setq data_list_neu (cons ent_data data_list_neu))
	(setq n (1+ n))
      )
      (command "z")
      (setq n 0)
      (setq data_list_alt (list))
      (repeat (sslength satz)
	(setq ent_name (ssname satz n))
	(setq ent_data (entget ent_name))
	(setq data_list_alt (cons ent_data data_list_alt))
	(setq n (1+ n))
      )
      (mk_angle_korr data_list_alt data_list_neu)
      (princ)
    )
  )
  (setvar "snapang" mem_snapang)
)

(defun c:k_m025	(/	  pic1	   pic2	    ent_name ent_data ent_name2
		 ent_data2	   anzahl   data     p_list   dat
		 bogen	  pline_satz	    satz     satz2    n
		 p	  w_max	   f
		)
;;; Multilinien abrunden

  (defun k_m025_pic (/ pic)
    (setq pic nil)
    (cond
      ((= fr "r")
       (while (null pic)
	 (initget "r")
	 (setq
	   pic (nentsel
		 (strcat "Objekt whlen oder r fr Radius <"
			 (rtos (getvar "filletrad"))
			 "> : "
		 )
	       )
	 )
	 (cond
	   ((= pic "r")
	    (setvar "filletrad" (getreal "Radius : "))
	    (setq pic nil)
	   )
	 )
       )
      )
      ((= fr "f")
       (while (null pic)
	 (initget "a w")
	 (cond
	   ((= (getvar "chammode") 0)
	    (setq
	      pic
	       (nentsel
		 (strcat
		   "Objekt whlen oder Abstand,Winkel fr Fase <"
		   (rtos (getvar "chamfera"))
		   ","
		   (rtos (getvar "chamferb"))
		   "> : "
		 )
	       )
	    )
	   )
	   ((= (getvar "chammode") 1)
	    (setq
	      pic
	       (nentsel
		 (strcat
		   "Objekt whlen oder Abstand,Winkel fr Fase <"
		   (rtos (getvar "chamferc"))
		   ","
		   (rtos (getvar "chamferd"))
		   "> : "
		 )
	       )
	    )
	   )
	 )
	 (cond
	   ((= pic "a")
	    (setvar "chamfera" (getdist "Abstand 1 : "))
	    (setvar "chamferb" (getdist "Abstand 2 : "))
	    (setvar "chammode" 0)
	    (setq pic nil)
	   )
	   ((= pic "w")
	    (setvar "chamferc"
		    (getdist "Abstand von der ersten Linie : ")
	    )
	    (setvar "chamferd" (getreal "Winkel : "))
	    (setvar "chammode" 1)
	    (setq pic nil)
	   )
	 )
       )
      )
    )
    pic
  )

  (defun k_m025_mk_mline ()
    (setq anzahl (sslength satz))
    (setq n 0)
    (setq pline_satz (ssadd))
    (repeat anzahl
      (setq ent_name (ssname satz n))
      (if ent_name
	(progn
	  (setq ent_data (entget ent_name))
	  (cond
	    ((= (cdr (assoc 0 ent_data)) "LINE")
	     (setq p (cons 10
			   (mapcar '*
				   (cdr (assoc 10 ent_data))
				   (list 1.0 1.0 0.0)
			   )
		     )
	     )
	     (setq
	       ent_data
		(subst p (assoc 10 ent_data) ent_data)
	     )
	     (setq p (cons 11
			   (mapcar '*
				   (cdr (assoc 11 ent_data))
				   (list 1.0 1.0 0.0)
			   )
		     )
	     )
	     (setq
	       ent_data
		(subst p (assoc 11 ent_data) ent_data)
	     )
	    )
	    ((= (cdr (assoc 0 ent_data)) "ARC")
	     (setq p (cons 10
			   (mapcar '*
				   (cdr (assoc 10 ent_data))
				   (list 1.0 1.0 0.0)
			   )
		     )
	     )
	     (setq
	       ent_data
		(subst p (assoc 10 ent_data) ent_data)
	     )
	    )
	  )
	  (entmod ent_data)
	  (command "pedit" ent_name "j" "br" breite "x")
	  (setq pline_satz (ssadd (entlast) pline_satz))
	)				;end progn
      )					;end if
      (setq n (1+ n))
    )					;end repeat
    (setq anzahl (sslength pline_satz))
    (setq n 0)
    (repeat anzahl
      (if pline_satz
	(progn
	  (setq ent_name (ssname pline_satz n))
	  (command "_pedit" ent_name "v" pline_satz "")
	  (while (/= (getvar "cmdactive") 0)
	    (command "x")
	  )
	  (setq pline_satz (ssget "_p"))
	  (if pline_satz
	    (if	(= anzahl (sslength pline_satz))
	      (setq n (1+ n))
	      (setq n 0)
	    )
	  )				;end if
	)
      )					;end if
    )					;end repeat
    (setq satz (ssget "l"))
    (setq w_max (* (/ 5 180.0) pi))
    (setq f nil)
    (repeat (sslength satz)
      (princ "\r")
      (princ n)
      (princ "  ")
      (setq ent_data (entget (setq ent_name (ssname satz n))))
      (setq p_list (list))
      (setq bogen f)
      (foreach dat ent_data
	(if (= (car dat) 10)
	  (progn
	    (if	bogen
	      (rechne_bogen (car p_list) (cdr dat))
	    )
	    (setq p_list (cons (cdr dat) p_list))
	    (setq bogen f)
	  )
	)
	(if (= (car dat) 42)
	  (progn
	    (if	(/= (cdr dat) 0)
	      (setq bogen (cdr dat))
	      (setq bogen f)
	    )
	  )
	)
      )
      (if (= (rem (cdr (assoc 70 ent_data)) 2) 1)
	(if bogen
	  (rechne_bogen (car p_list) (car (reverse p_list)))
	)
      )
      (setq p_list (reverse p_list))
      (command "_mline")
      (foreach p p_list
	(command p)
      )
      (if (= (rem (cdr (assoc 70 ent_data)) 2) 1)
	(command "s")
      )
      (while (= (getvar "cmdactive") 1) (command ""))
      (entdel ent_name)
      (setq n (1- n))
    )
  )

  (vla-startundomark (k_ac-doc))
  (setq fr (k_get_hauptliste "k_m025"))
  (setq pic1 (k_m025_pic))
  (if pic1
    (progn
      (setq mline_name (nth 0 pic1))
      (setq mline_data (entget mline_name))
      (if (= (cdr (assoc 0 mline_data)) "MLINE")
	(progn
	  (setvar "cmlstyle" (cdr (assoc 2 mline_data)))
	  (setq px (nth 1 pic1))
	  (setq p (cdr (assoc 10 mline_data)))
	  (foreach data	mline_data
	    (if	(= (car data) 11)
	      (progn
		(if (< (distance (cdr data) px) (distance p px))
		  (setq p (cdr data))
		)
	      )
	    )
	  )
	  (setvar "clayer" (cdr (assoc 8 mline_data)))
	  (setq p_list (list))
	  (foreach dat mline_data
	    (if	(= (car dat) 11)
	      (setq p_list (cons (cdr dat) p_list))
	    )
	  )
	  (setq p_list (reverse p_list))
	  (command "_pline")
	  (foreach p p_list
	    (command p)
	  )
	  (if (= (cdr (assoc 71 mline_data)) 3)
	    (command "s")
	  )
	  (while (= (getvar "cmdactive") 1) (command ""))
	  (command "_explode" (entlast))
	  (setq satz (ssget "_p"))
	  (setq n (1- (sslength satz)))
	  (setq ent_list (list))
	  (repeat (sslength satz)
	    (setq ent_name (ssname satz n))
	    (setq ent_data (entget ent_name))
	    (if	(equal (cdr (assoc 10 ent_data)) p)
	      (setq ent_list (cons ent_name ent_list))
	    )
	    (if	(equal (cdr (assoc 11 ent_data)) p)
	      (setq ent_list (cons ent_name ent_list))
	    )
	    (setq n (1- n))
	  )
	  (if (= (length ent_list) 1)
	    (progn
	      (setq pic2 (k_m025_pic))
	      (if pic2
		(progn
		  (setq mline_name2 (nth 0 pic2))
		  (setq mline_data2 (entget mline_name2))
		  (if (= (cdr (assoc 0 mline_data2)) "MLINE")
		    (progn
		      (setvar "cmlstyle" (cdr (assoc 2 mline_data2)))
		      (setq px (nth 1 pic2))
		      (setq p (cdr (assoc 10 mline_data2)))
		      (foreach data mline_data2
			(if (= (car data) 11)
			  (progn
			    (if	(< (distance (cdr data) px)
				   (distance p px)
				)
			      (setq p (cdr data))
			    )
			  )
			)
		      )
		      (setvar "clayer" (cdr (assoc 8 mline_data2)))
		      (setq p_list (list))
		      (foreach dat mline_data2
			(if (= (car dat) 11)
			  (setq p_list (cons (cdr dat) p_list))
			)
		      )
		      (setq p_list (reverse p_list))
		      (command "_pline")
		      (foreach p p_list
			(command p)
		      )
		      (if (= (cdr (assoc 71 mline_data2)) 3)
			(command "s")
		      )
		      (while (= (getvar "cmdactive") 1) (command ""))
		      (command "_explode" (entlast))
		      (setq satz2 (ssget "_p"))
		      (setq n (1- (sslength satz2)))
		      (setq ent_list2 (list))
		      (repeat (sslength satz2)
			(setq ent_name (ssname satz2 n))
			(setq satz (ssadd ent_name satz))
			(setq ent_data (entget ent_name))
			(if (equal (cdr (assoc 10 ent_data)) p)
			  (setq ent_list2 (cons ent_name ent_list2))
			)
			(if (equal (cdr (assoc 11 ent_data)) p)
			  (setq ent_list2 (cons ent_name ent_list2))
			)
			(setq n (1- n))
		      )
		      (entdel mline_name)
		      (cond
			((= fr "r")
			 (command "_fillet"
				  (nth 0 ent_list)
				  (nth 0 ent_list2)
			 )
			)
			((= fr "f")
			 (command "_chamfer"
				  (nth 0 ent_list)
				  (nth 0 ent_list2)
			 )
			)
		      )
		      (setq satz (ssadd (entlast) satz))
		      (k_m025_mk_mline)
		    )
		  )
		)
	      )
	    )
	    (progn
	      (entdel mline_name)
	      (cond
		((= fr "r")
		 (command "_fillet" (nth 0 ent_list) (nth 1 ent_list))
		)
		((= fr "f")
		 (command "_chamfer" (nth 0 ent_list) (nth 1 ent_list))
		)
	      )
	      (setq satz (ssadd (entlast) satz))
	      (k_m025_mk_mline)
	    )
	  )
	)
      )
    )
  )
  (vla-endundomark (k_ac-doc))
  (princ)
)

(defun c:k_m026	()
;;; Multiliniensegmente hinzufgen
  (defun m026_mline_pline (ent_name / ent_data p_list dat bogen p)
    (setq ent_data (entget ent_name))
    (setq bogen f)
    (setvar "clayer" (cdr (assoc 8 ent_data)))
    (setq p_list (list))
    (foreach dat ent_data
      (if (= (car dat) 11)
	(progn
	  (if bogen
	    (rechne_bogen (car p_list) (cdr dat))
	  )
	  (setq p_list (cons (cdr dat) p_list))
	  (setq bogen f)
	)
      )
    )
    (setq p_list (reverse p_list))
    (command "_pline")
    (foreach p p_list
      (command p)
    )
    (if	(= (cdr (assoc 71 ent_data)) 3)
      (command "s")
    )
    (while (= (getvar "cmdactive") 1) (command ""))
    (entdel ent_name)
    (setq ent_name (entlast))
  )

  (defun m026_pline_mline
	 (ent_name / w_max f bogen ent_data p_list dat p mem_osmode)
    (setvar "cmdecho" 0)
    (setq w_max (* (/ 5 180.0) pi))
    (setq f nil)
    (setq mem_osmode (getvar "osmode"))
    (setvar "osmode" 0)
    (setq bogen f)
    (setq ent_data (entget ent_name))
    (setq p_list (list))
    (setq bogen f)
    (foreach dat ent_data
      (if (= (car dat) 10)
	(progn
	  (if bogen
	    (rechne_bogen (car p_list) (cdr dat))
	  )
	  (setq p_list (cons (cdr dat) p_list))
	  (setq bogen f)
	)
      )
      (if (= (car dat) 42)
	(progn
	  (if (/= (cdr dat) 0)
	    (setq bogen (cdr dat))
	    (setq bogen f)
	  )
	)
      )
    )
    (if	(= (rem (cdr (assoc 70 ent_data)) 2) 1)

      (if bogen
	(rechne_bogen (car p_list) (car (reverse p_list)))
      )
    )
    (setq p_list (reverse p_list))
    (command "_mline")
    (foreach p p_list
      (command p)
    )
    (if	(= (rem (cdr (assoc 70 ent_data)) 2) 1)
      (command "s")
    )
    (while (= (getvar "cmdactive") 1) (command ""))
    (entdel ent_name)
    (setvar "osmode" mem_osmode)
    (setvar "cmdecho" 0)
  )
  (vla-startundomark (k_ac-doc))

  (setq pic1 nil)
  (while (null pic1)
    (initget "r")
    (setq pic1 (entsel (strcat "erstes Objekt oder r fr Radius <"
			       (rtos (getvar "filletrad"))
			       "> : "
		       )
	       )
    )
    (cond
      ((= pic1 "r")
       (setvar "filletrad" (getreal "Radius : "))
       (setq pic1 nil)
      )
    )
  )
  (setq pic2 nil)
  (while (null pic2)
    (initget "r")
    (setq pic2 (entsel (strcat "zweites Objekt oder r fr Radius <"
			       (rtos (getvar "filletrad"))
			       "> : "
		       )
	       )
    )
    (cond
      ((= pic2 "r")
       (setvar "filletrad" (getreal "Radius : "))
       (setq pic2 nil)
      )
    )
  )
  (setq ent1_name (nth 0 pic1))
  (setq ent2_name (nth 0 pic2))
  (setq p1 (nth 1 pic1))
  (setq p2 (nth 1 pic2))
  (setq ent1_data (entget ent1_name))
  (setq ent2_data (entget ent2_name))
  (if (= (cdr (assoc 0 ent1_data)) "MLINE")
    (progn
      (if (assoc 48 ent1_data)
	(setvar "celtscale" (cdr (assoc 48 ent1_data)))
	(setvar "celtscale" 1)
      )
      (setvar "cmlstyle" (cdr (assoc 2 ent1_data)))
      (setvar "cmlscale" (cdr (assoc 40 ent1_data)))
      (setvar "cmljust" (cdr (assoc 70 ent1_data)))
    )
    (if	(= (cdr (assoc 0 ent2_data)) "MLINE")
      (progn
	(if (assoc 48 ent2_data)
	  (setvar "celtscale" (cdr (assoc 48 ent2_data)))
	  (setvar "celtscale" 1)
	)
	(setvar "cmlstyle" (cdr (assoc 2 ent2_data)))
	(setvar "cmlscale" (cdr (assoc 40 ent2_data)))
	(setvar "cmljust" (cdr (assoc 70 ent2_data)))
      )
    )
  )
  (setvar "clayer" (cdr (assoc 8 ent1_data)))
  (cond
    ((= (cdr (assoc 0 ent1_data)) "MLINE")
     (setq ent1_name (m026_mline_pline ent1_name))
    )
    ((= (cdr (assoc 0 ent1_data)) "LINE")
     (command "pedit" ent1_name "j" "")
     (setq ent1_name (entlast))
    )
    ((= (cdr (assoc 0 ent1_data)) "ARC")
     (command "pedit" ent1_name "j" "")
     (setq ent1_name (entlast))
    )
  )
  (cond
    ((= (cdr (assoc 0 ent2_data)) "MLINE")
     (setq ent2_name (m026_mline_pline ent2_name))
    )
    ((= (cdr (assoc 0 ent2_data)) "LINE")
     (command "pedit" ent2_name "j" "")
     (setq ent2_name (entlast))
    )
    ((= (cdr (assoc 0 ent2_data)) "ARC")
     (command "pedit" ent2_name "j" "")
     (setq ent2_name (entlast))
    )
  )
  (setq ent1_data (entget ent1_name))
  (setq ent2_data (entget ent2_name))
  (if (<= (distance p1 (cdr (assoc 10 ent1_data)))
	  (distance p1 (cdr (assoc 10 (reverse ent1_data))))
      )
    (setq px1 (cdr (assoc 10 ent1_data)))
    (setq px1 (cdr (assoc 10 (reverse ent1_data))))

  )
  (if (<= (distance p2 (cdr (assoc 10 ent2_data)))
	  (distance p2 (cdr (assoc 10 (reverse ent2_data))))
      )
    (setq px2 (cdr (assoc 10 ent2_data)))
    (setq px2 (cdr (assoc 10 (reverse ent2_data))))
  )
  (setq mem_pickbox (getvar "pickbox"))
  (setvar "pickbox" 0)
  (command "_fillet" px1 px2)
  (m026_pline_mline ent1_name)
  (setvar "pickbox" mem_pickbox)
  (vla-endundomark (k_ac-doc))
  (princ)
)

(defun c:k_m027	(/ D L L_LIST P1 P2 P_LIST SL)
;;;  Multilinien in Schusslngen einteilen
  (if (null (setq sl (getreal "Schusslnge <3000> : ")))
    (setq sl 3000.0)
  )
  (vla-startundomark (k_ac-doc))
  (foreach obj_name (k_satz->objlist (ssget '((0 . "MLINE"))))
    (setq
      p_list (gather (vlax-safearray->list
		       (variant-value (vla-get-coordinates obj_name))
		     )
		     3
	     )
    )
    (setq
      p_list
       (apply
	 'append
	 (cons
	   (car p_list)
	   (apply
	     'append
	     (mapcar
	       '(lambda	(p1 p2 / l l_list d)
		  (setq l 0.0)
		  (repeat (fix (/ (setq d (distance p1 p2)) sl))
		    (setq l (+ l sl))
		    (setq
		      l_list (cons (polar p1 (angle p1 p2) l)
				   l_list
			     )
		    )
		  )
		  (append (reverse l_list) (list p2))
		)
	       (reverse (cdr (reverse p_list)))
	       (cdr p_list)
	     )
	   )
	 )
       )
    )
    (vla-put-coordinates
      obj_name
      (k_liste->variant p_list 8197)
    )
  )
  (vla-endundomark (k_ac-doc))
  (princ)
)

